/*GRB*

Gerbera - https://gerbera.io/

    device_description_handler.h - this file is part of Gerbera.

    Copyright (C) 2019 Gerbera Contributors

    Gerbera is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2
    as published by the Free Software Foundation.

    Gerbera is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
*/

/// \file device_description_handler.h

#ifndef GERBERA_DEVICE_DESCRIPTION_HANDLER_H
#define GERBERA_DEVICE_DESCRIPTION_HANDLER_H

#include "request_handler.h"
#include "upnp_xml.h"

class DeviceDescriptionHandler : public RequestHandler {
public:
    explicit DeviceDescriptionHandler(UpnpXMLBuilder* xmlBuilder);

    void getInfo(IN const char *filename, OUT UpnpFileInfo *info) override;
    zmm::Ref<IOHandler> open(IN const char* filename, IN enum UpnpOpenFileMode mode, IN zmm::String range) override;

protected:
    UpnpXMLBuilder* xmlBuilder;
    zmm::String deviceDescription;
};



#endif //GERBERA_DEVICE_DESCRIPTION_HANDLER_H
